#!/bin/bash
#
#   Hitachi Fibre Channel Adapter Driver Installer for RHEL5
#
#   $Header: /home/cvs_linux/tools/install/Attic/hfcinst.el5.sh,v 1.1.2.7.2.1 2008/04/16 07:05:18 eteshima Exp $
#   $Log: hfcinst.el5.sh,v $
#   Revision 1.1.2.7.2.1  2008/04/16 07:05:18  eteshima
#   FCLNX-519 Modifies hfcldd.spec.el5 and hfcinst.el5.sh
#
#   Revision 1.1.2.7  2008/01/11 07:32:47  nkubota
#   FCLNX-0507 RASLOG support
#
#   Revision 1.1.2.6  2007/12/26 04:36:10  nkubota
#   FCLNX-0502 RHEL5 PAE support
#
#   Revision 1.1.2.5  2007/12/19 04:22:20  toyo
#    Updates hfcinst.el5.sh
#
#   Revision 1.1.2.4  2007/12/18 08:30:04  toyo
#   Modifies Directory existing hraslog.ko.
#
#   Revision 1.1.2.3  2007/12/03 11:27:39  nkubota
#   FCLNX-0484 Fix for modify modprobe.conf
#
#   Revision 1.1.2.2  2007/11/13 04:06:58  nkubota
#   FCLNX-0463 RASLOG support
#
#   Revision 1.1.2.1  2007/10/26 01:31:32  nkubota
#   FCLNX-0440 RHEL5 support
#
#
if [ "$1" != "install" -a "$1" != "uninstall" ]; then
        echo "Usage : hfcinst.el5.sh install/uninstall [kvariant]"
        echo "example(install  ) : hfcinst.el5.sh install"
        echo "       (uninstall) : hfcinst.el5.sh uninstall"
        exit 1
fi
DRVDIR="drivers"
DRVMODU="hfcldd"
CNFMODU="hfcldd_conf"
MPMODU="hfcldd_mp"
RLOGLINK="hraslog_link.ko"
RASLOG="hraslog.ko"
HOSTTYPE=$(uname -m)
TOOLSDIR="/opt/hitachi/drivers/hba"
INSTLOG="/tmp/hfcldd_install.log"
if [ "$HOSTTYPE" = "i686" ] && [ "$2" = "PAE" ]; then
	KERN50="2.6.18-8.el5PAE"
	KERN51="2.6.18-53.el5PAE"
	if [ `uname -r | grep "PAE"` ]; then
		KERNVER=`uname -r`
	else
		KERNVER="`uname -r`PAE"
	fi
elif [ "$HOSTTYPE" = "i686" ]; then
	KERN50="2.6.18-8.el5"
	KERN51="2.6.18-53.el5"
	KERNVER=`uname -r | sed -e 's/PAE//'`
else
	KERN50="2.6.18-8.el5"
	KERN51="2.6.18-53.el5"
	KERNVER=`uname -r`
fi
KERNEL2=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,\..*,,'`
KERNEL3=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,[^\.]*\.,,' -e 's,\-.*,,'`
if [ "$HOSTTYPE" = "ia64" ]; then
	BOOTDIR="boot/efi/efi/redhat"
else
	BOOTDIR="boot"
fi
echo "      Boot directory      : $BOOTDIR" > $INSTLOG
if [ $KERNEL2 = "4" ] || [ $KERNEL3 = "9" ]; then
	echo " ---- Kernel version is 2.4 or 2.6.9 (/etc/$MODCONF)"  >> $INSTLOG
	exit 1
fi
MODCONF="modprobe.conf"
if [ ! -f "/etc/$MODCONF" ]; then
	echo " ---- No configuration file was found (/etc/$MODCONF)"  >> $INSTLOG
	exit 1
fi
DRVNAME="hfcldd.ko"
CNFNAME="hfcldd_conf.ko"
echo "      Configulation file  : $MODCONF"    >> $INSTLOG
echo "      Kernel version      : $KERNVER"    >> $INSTLOG
echo "      Host Type           : `uname -m`"  >> $INSTLOG
if [ "$1" = "install" ]; then
	echo " ---- Install  @Hitachi Fibre Channel Adapter Driver - `date`" >> $INSTLOG
	find /lib/modules/$KERNVER/updates -name $RLOGLINK -exec mv {} {}.hraslog.rename \;
	if [ ! -f "/lib/modules/$KERN51/extra/hraslog/hraslog.ko" ]; then
		echo "        hraslog.ko is not installed"   >> $INSTLOG
	else
		echo "        hraslog.ko is already installed"   >> $INSTLOG
		echo "        - rename hraslog_link.ko"   >> $INSTLOG
		cp  /lib/modules/$KERN50/extra/hitachi/hfcldd/$RLOGLINK /lib/modules/$KERN50/extra/hitachi/hfcldd/$RLOGLINK.hraslog.rename
	fi
	find /lib/modules/$KERNVER/updates -name $DRVNAME -exec mv {} {}.backup \;
	find /lib/modules/$KERNVER/updates -name $CNFNAME -exec mv {} {}.backup \;
	find /lib/modules/$KERNVER/kernel  -name $DRVNAME -exec mv {} {}.backup \;
	find /lib/modules/$KERNVER/kernel  -name $CNFNAME -exec mv {} {}.backup \;
	echo "      Modify /etc/$MODCONF; old file is /etc/$MODCONF.backup"   >> $INSTLOG
	cp /etc/$MODCONF /etc/$MODCONF.backup
	sed '/^#/s/scsi_hostadapter/hoge_hogehoge/g' /etc/$MODCONF > /etc/$MODCONF.temp
	mv /etc/$MODCONF.temp /etc/$MODCONF
	if [ `grep -c "scsi_hostadapter[0-9]*[[:space:]]\+hfcldd" /etc/$MODCONF` -eq 0 ]; then
		COUNT=`grep -c "scsi_hostadapter" /etc/$MODCONF`
		if [ $COUNT -eq 0 ]; then
			echo "alias scsi_hostadapter0 hfcldd_conf" >> /etc/$MODCONF
			echo "alias scsi_hostadapter1 hfcldd" >> /etc/$MODCONF
		elif [ $COUNT -eq 1 ]; then
			#########################################################################################################
			#
			# the following cases:
			#  1. alias scsi_hostadapter xxxxxx
			#
			#  2. alias scsi_hostadapterN xxxxxx
			#
			# after modified:
			#  1. alias scsi_hostadapter xxxxxx
			#     alias scsi_hostadapter1 hfcldd_conf
			#     alias scsi_hostadapter2 hfcldd
			#
			#  2. alias scsi_hostadapterN xxxxxx
			#     alias scsi_hostadapterN+1 hfcldd_conf
			#     alias scsi_hostadapterN+2 hfcldd
			#
			#########################################################################################################
			if [ `grep -c "scsi_hostadapter[ ]" /etc/$MODCONF` -eq 0 ]; then
				COUNT=`sed -n s/alias[[:space:]]*scsi_hostadapter//p /etc/$MODCONF|awk 'BIGIN{n=0};$1>n{n=$1};END{print n}'`
				LN=`sed -n /scsi_hostadapter0*$COUNT/{=} /etc/$MODCONF`
				COUNT=`expr $COUNT + 1`
				sed "$LN"a"alias scsi_hostadapter$COUNT hfcldd_conf" /etc/$MODCONF > /etc/$MODCONF.temp
				COUNT=`expr $COUNT + 1`
				LN=`expr $LN + 1`
				cp /etc/$MODCONF.temp /etc/$MODCONF
				sed "$LN"a"alias scsi_hostadapter$COUNT hfcldd" /etc/$MODCONF > /etc/$MODCONF.temp
				mv /etc/$MODCONF.temp /etc/$MODCONF
			else
				LN=`sed -n /scsi_hostadapter/{=} /etc/$MODCONF`
				sed "$LN"a"alias scsi_hostadapter$COUNT hfcldd_conf" /etc/$MODCONF > /etc/$MODCONF.temp
				cp /etc/$MODCONF.temp /etc/$MODCONF
				COUNT=`expr $COUNT + 1`
				LN=`expr $LN + 1`
				sed "$LN"a"alias scsi_hostadapter$COUNT hfcldd" /etc/$MODCONF > /etc/$MODCONF.temp
				mv /etc/$MODCONF.temp /etc/$MODCONF
			fi
		else
			#########################################################################################################
			#
			# the following cases:
			#  1. alias scsi_hostadapter xxxxxx
			#     alias scsi_hostadapterN xxxxxx
			#
			#  2. alias scsi_hostadapterM xxxxxx
			#     alias scsi_hostadapterN xxxxxx
			#
			# after modified:
			#  1. alias scsi_hostadapter xxxxxx
			#     alias scsi_hostadapterN+1 hfcldd_conf
			#     alias scsi_hostadapterN+2 hfcldd
			#
			#  2. alias scsi_hostadapterM xxxxxx
			#     alias scsi_hostadapterN+1 hfcldd_conf
			#     alias scsi_hostadapterN+2 hfcldd
			#
			#########################################################################################################
			cp /etc/$MODCONF /etc/$MODCONF.temp
			ADAP=`grep -c "scsi_hostadapter[ ]" /etc/$MODCONF`
			ADAP0=`grep -c "scsi_hostadapter0*0[ ]" /etc/$MODCONF`
			if [ $ADAP -gt 2 ] || [ $ADAP0 -gt 2 ]; then
				echo " @ERR double assigned scsi_hostadapter number" >> $INSTLOG
				sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/$MODCONF > /etc/$MODCONF.temp
				mv /etc/$MODCONF.temp /etc/$MODCONF
				exit 1
			fi
			if [ $ADAP -eq 1 ]; then
				# intentional character
				sed s/"scsi_hostadapter "/"scsi_xxxxxxxxxxx "/ /etc/$MODCONF > /etc/$MODCONF.temp
			fi
			COUNT=`sed -n s/alias[[:space:]]*scsi_hostadapter//p /etc/$MODCONF.temp|awk 'BIGIN{n=0};$1>n{n=$1};END{print n}'`
			LN=`sed -n /scsi_hostadapter0*$COUNT/{=} /etc/$MODCONF.temp`
			COUNT=`expr $COUNT + 1`
			sed "$LN"a"alias scsi_hostadapter$COUNT hfcldd_conf" /etc/$MODCONF > /etc/$MODCONF.temp
			COUNT=`expr $COUNT + 1`
			LN=`expr $LN + 1`
			cp /etc/$MODCONF.temp /etc/$MODCONF
			sed "$LN"a"alias scsi_hostadapter$COUNT hfcldd" /etc/$MODCONF > /etc/$MODCONF.temp
			mv /etc/$MODCONF.temp /etc/$MODCONF
		fi
	else
		if [ `grep -c "scsi_hostadapter[0-9]*[[:space:]]\+hfcldd_mp" /etc/$MODCONF` -eq 1 ]; then
			# delete hfcldd_mp line
			sed "s/\(scsi_hostadapter.*\) hfcldd_conf/\1 temp_conf/" /etc/$MODCONF > /etc/$MODCONF.temp
			sed "s/\(scsi_hostadapter.*\) hfcldd_mp/\1 temp_mp/" /etc/$MODCONF.temp > /etc/$MODCONF.temp2
			sed '/alias scsi_hostadapter.* hfcldd/d' /etc/$MODCONF.temp2 > /etc/$MODCONF.temp
			sed "s/\(scsi_hostadapter.*\) temp_conf/\1 hfcldd_conf/" /etc/$MODCONF.temp > /etc/$MODCONF.temp2
			sed "s/\(scsi_hostadapter.*\) temp_mp/\1 hfcldd/" /etc/$MODCONF.temp2 > /etc/$MODCONF
			rm /etc/$MODCONF.temp*
		fi
		if [ `grep -c "scsi_hostadapter[0-9]*[[:space:]]\+hfcldd_conf" /etc/$MODCONF` -eq 0 ]; then
			cp /etc/$MODCONF /etc/$MODCONF.temp
			ADAP=`grep -c "scsi_hostadapter[ ]" /etc/$MODCONF`						# number of "alias scsi_hostadapter"
			HADAP=`grep -c "scsi_hostadapter[[:space:]]\+hfcldd" /etc/$MODCONF`		# number of "alias scsi_hostadapter hfcldd"
			ADAP0=`grep -c "scsi_hostadapter0*0[ ]" /etc/$MODCONF`					# number of "alias scsi_hostadapter0 or 00"
			if [ $ADAP -gt 2 ] || [ $ADAP0 -gt 2 ]; then
				echo " @ERR double assigned scsi_hostadapter number" >> $INSTLOG
				sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/$MODCONF > /etc/$MODCONF.temp
				mv /etc/$MODCONF.temp /etc/$MODCONF
				exit 1
			fi
			if [ $ADAP -eq 1 ]; then
				if [ $HADAP -eq 0 ]; then
					# intentional character
					sed s/"scsi_hostadapter "/"scsi_xxxxxxxxxxx "/ /etc/$MODCONF > /etc/$MODCONF.temp
				else
					sed s/"scsi_hostadapter "/"scsi_hostadapter0 "/ /etc/$MODCONF > /etc/$MODCONF.temp
					cp /etc/$MODCONF.temp /etc/$MODCONF
				fi
			fi
			LO=`sed -n s/alias[[:space:]]*scsi_hostadapter//p /etc/$MODCONF.temp|awk 'BIGIN{n=0};$1>n{n=$1};END{print n}'`
			TMP=`grep -n "scsi_hostadapter[0-9]*[[:space:]]\+hfcldd" /etc/$MODCONF.temp`
			LN=`echo $TMP | awk '{split($0,a,":"); print a[1]}'`
			CONFNO=`echo $TMP | awk '{split($0,a,":"); print a[2]}'| awk '{print $2}'|sed s/scsi_hostadapter//`
			LO=`expr $LO + 1`
			ENDNO=`expr $CONFNO`
			while [ $LO -gt $ENDNO ]; do
				LI=`expr $LO - 1`
				if [ $ADAP -eq 1 ] && [ $HADAP -eq 1 ] && [ $ADAP0 -eq 1 ]; then
					#########################################################################################################
					#
					# the following cases:
					#   alias scsi_hostadapter hfcldd
					#   alias scsi_hostadapter0 xxxxxx  (alias scsi_hostadapter00 xxxxxx)
					#   alias scsi_hostadapterN xxxxxx
					#
					# after modified:
					#   alias scsi_hostadapter0 hfcldd_conf
					#   alias scsi_hostadapter1 hfcldd
					#	alias scsi_hostadapter2 xxxxxx  (alias scsi_hostadapter02 xxxxxx)
					#   alias scsi_hostadapterN+2 xxxxxx
					#
					#########################################################################################################
					LP=`expr $LO + 1`
					if [ $LI -eq 0 ]; then
						sed "s/\(scsi_hostadapter0*\)$LI[[:space:]]\+hfcldd/\1$LO hfcldd/" /etc/$MODCONF > /etc/$MODCONF.temp2
						if [ `grep -c "scsi_hostadapter00[ ]" /etc/$MODCONF` -eq 0 ]; then
							sed s/"scsi_hostadapter0 "/"scsi_hostadapter$LP "/ /etc/$MODCONF.temp2 > /etc/$MODCONF.temp
						else
							sed s/"scsi_hostadapter00 "/"scsi_hostadapter0$LP "/ /etc/$MODCONF.temp2 > /etc/$MODCONF.temp
						fi
						rm /etc/$MODCONF.temp2
					elif [ $LI -gt 9 ]; then
						# scsi_hostadapterXX: XX=10-
						sed "s/\(scsi_hostadapter\)$LI[[:space:]]/\1$LP /" /etc/$MODCONF > /etc/$MODCONF.temp
					else
						if [ `grep -c "scsi_hostadapter0$LI[ ]" /etc/$MODCONF` -eq 0 ]; then
							# scsi_hostadapterXX: XX=1digit, X=0-9
							sed "s/\(scsi_hostadapter\)$LI[[:space:]]/\1$LP /" /etc/$MODCONF > /etc/$MODCONF.temp
						elif [ $LI -eq 8 ] || [ $LI -eq 9 ]; then
							# scsi_hostadapterXX: XX=2digit, XX=08 or 09
							sed "s/scsi_hostadapter0$LI[[:space:]]/scsi_hostadapter$LP /" /etc/$MODCONF > /etc/$MODCONF.temp
						else
							# scsi_hostadapterXX: XX=2digit, XX=00-07
							sed "s/\(scsi_hostadapter0\)$LI[[:space:]]/\1$LP /" /etc/$MODCONF > /etc/$MODCONF.temp
						fi
					fi
				else
					#########################################################################################################
					#
					# the following cases:
					#  1. alias scsi_hostadapter hfcldd
					#     alias scsi_hostadapterN xxxxxx
					#
					#  2. alias scsi_hostadapter xxxxxx
					#     alias scsi_hostadapterN hfcldd
					#
					#  3. alias scsi_hostadapterN hfcldd
					#
					# after modified:
					#  1. alias scsi_hostadapter0 hfcldd_conf
					#     alias scsi_hostadapter1 hfcldd
					# 	  alias scsi_hostadapterN+1 xxxxxx
					#  
					#  2. alias scsi_hostadapter xxxxxx
					#     alias scsi_hostadapterN hfcldd_conf
					#     alias scsi_hostadapterN+1 hfcldd
					#
					#  3. alias scsi_hostadapterN hfcldd_conf
					#     alias scsi_hostadapterN+1 hfcldd
					#
					#########################################################################################################
					if [ $LI -gt 9 ]; then
						sed "s/\(scsi_hostadapter\)$LI[[:space:]]/\1$LO /" /etc/$MODCONF > /etc/$MODCONF.temp
					else
						if [ `grep -c "scsi_hostadapter0$LI[ ]" /etc/$MODCONF` -eq 0 ]; then
							# scsi_hostadapterXX: XX=1digit, X=0-9
							sed "s/\(scsi_hostadapter\)$LI[[:space:]]/\1$LO /" /etc/$MODCONF > /etc/$MODCONF.temp
						elif [ $LI -eq 9 ]; then
							# scsi_hostadapterXX: XX=2digit, XX=09
							sed "s/scsi_hostadapter0$LI[[:space:]]/scsi_hostadapter$LO /" /etc/$MODCONF > /etc/$MODCONF.temp
						else
							# scsi_hostadapterXX: XX=2digit, XX=00-08
							sed "s/\(scsi_hostadapter0\)$LI[[:space:]]/\1$LO /" /etc/$MODCONF > /etc/$MODCONF.temp
						fi
					fi
				fi
				cp /etc/$MODCONF.temp /etc/$MODCONF
				LO=`expr $LO - 1`
			done
			if [ $LN -gt 1 ]; then
				LN=`expr $LN - 1`
				sed "$LN"a"alias scsi_hostadapter$CONFNO hfcldd_conf" /etc/$MODCONF > /etc/$MODCONF.temp
			else
				sed "$LN"i"alias scsi_hostadapter$CONFNO hfcldd_conf" /etc/$MODCONF > /etc/$MODCONF.temp
			fi
   	    	mv /etc/$MODCONF.temp /etc/$MODCONF
		fi
	fi
	sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/$MODCONF > /etc/$MODCONF.temp
	mv /etc/$MODCONF.temp /etc/$MODCONF
	echo " ---- Install Success "   >> $INSTLOG
else
	echo " ---- Uninstall  @Hitachi Fibre Channel Adapter Driver - `date`"   > $INSTLOG
	if [ -f "/lib/modules/$KERN51/extra/hraslog/hraslog.ko" ]; then
		rm -f /lib/modules/$KERN50/extra/hitachi/hfcldd/$RLOGLINK.hraslog.rename
	fi
	echo "      Modify /etc/$MODCONF"   >> $INSTLOG
	sed '/^#/s/scsi_hostadapter/hoge_hogehoge/g' /etc/$MODCONF > /etc/$MODCONF.temp
	sed '/alias scsi_hostadapter.* hfcldd/d' /etc/$MODCONF.temp > /etc/$MODCONF
	rm /etc/$MODCONF.temp
	rm -f $LIBMODULE/scsi/$CNFNAME
	cp /etc/$MODCONF /etc/$MODCONF.temp
	sed '/alias scsi_hostadapter.* hfcldd_conf/d' /etc/$MODCONF.temp > /etc/$MODCONF
	sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/$MODCONF > /etc/$MODCONF.temp
	mv /etc/$MODCONF.temp /etc/$MODCONF
    echo " ---- Uninstall Success "   >> $INSTLOG
fi
